var URL_AJAX_ACTION = "/action/json_data"

function ajaxActionWrap(actionData, callback)
{
	$.post(URL_AJAX_ACTION,
		{
			data: actionData,
		},
		function(data, status){
			if(callback)
				callback(data, status)
		}
	);
	/*
	$.ajax({
	  type: 'POST',
	  url: URL_AJAX_ACTION,
	  data: actionData,
	  success: 
		function(data, status){
				if(callback)
					callback(data, status)
		},
	  dataType: "json"
	});
	*/
}

var loginType = 0;

var timeId = 0;
var refreshCount = 0;

var jsCookie = "";

var count = 0;

function RefreshPage(fun, time, count)
{
	window.clearInterval(timeId);
	timeId = window.setInterval(fun, time);
	refreshCount = count;
}

/* wifi status: json = "[{'status': 'success', 'code': 1, 'wifi_status':{'ssid':'1111', 'status'1:1} }]" */
function getWifiStatusCallBack(data, status)
{
	if(status != "success")
	{
		alert("get wifi status failed!\n");
		return;
	}else{
		var jobj = eval(data)
		if(jobj)
		{
			if(jobj[0].code != 1)
			{
				return 0;
			}
			
			$("#wifiCurAp").html(jobj[0].wifi_status.ssid);
			if(jobj[0].wifi_status.status == 1)
			{
				$("#wifiCurStatus").css("color", "#00a4ff");
				$("#wifiCurStatus").html("已连接");
			}	
			else
			{
				$("#wifiCurStatus").css("color", "#d84e4e");
				$("#wifiCurStatus").html("未连接");
			}	
			devId = getCookie('devId');
			$("#labPrinterName").html(jobj[0].printerName);
			$("#edtPrinterName").val(jobj[0].printerName);
			document.title = "微云打-"+jobj[0].printerName;
			/*default printName*/
			$('#serverStatus').html(' ' + (jobj[0].netStatus == 1  ? 'ONLINE' : 'LOST'));

			if(jobj[0].wifi_status.status != 1)
			{
				showSetWifiPage();
			}else{
				showMainPage();
			}
		}else{
			$("#wifiCurStatus").html("未连接");
		}
	}
}

/*获取WIFI连接状态*/
function getWifiStatus()
{
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"wifi_status", "data":{"p1":1,"p2":2}}';
	ajaxActionWrap(data, getWifiStatusCallBack);
}


function getWifiStatusCallBack2(data, status)
{
	if(status != "success")
	{
		alert("get wifi status failed!\n");
		return;
	}else{
		var jobj = eval(data)
		if(jobj)
		{
			if(jobj[0].code != 1)
			{
				return 0;
			}
			
			$("#wifiCurAp").html(jobj[0].wifi_status.ssid);
			if(jobj[0].wifi_status.status == 1)
			{
				$("#wifiCurStatus").css("color", "#00a4ff");
				$("#wifiCurStatus").html("已连接");
				$("#waitgif").css("display","none");
			}	

			devId = getCookie('devId');
			$("#labPrinterName").html(jobj[0].printerName);
			$("#edtPrinterName").val(jobj[0].printerName);
			document.title = "微云打-"+jobj[0].printerName;
			/*default printName*/
			$('#serverStatus').html(' ' + (jobj[0].netStatus == 1  ? 'ONLINE' : 'LOST'));

			if(jobj[0].wifi_status.status == 1)
			{
				showMainPage();
			}
			else
			{
				setTimeout(getWifiStatus2, 1000);
			}
		}else{
			$("#wifiCurStatus").html("未连接");
		}
	}
}


/*获取WIFI连接状态*/
function getWifiStatus2()
{
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"wifi_status", "data":{"p1":1,"p2":2}}';
	ajaxActionWrap(data, getWifiStatusCallBack2);
}


function WifiConnCallBack(data, status)
{
	if(status != "success")
		{
			alert("Wifi conn failed!\n");
			return;
		}else{
			setTimeout(getWifiStatus2, 5000);//alert("Wifi conn status ok\n");
		}
}

function selectOnchange(id)
{
	var ssid = $("#wifiApList").find("option:selected").text();
	$("#edtSSID").val(ssid);
}

/*wifi连接*/
function btnWifiConnOnClick()
{
	var str = $("#edtSSID").val();
	if(!str)
	{
		alert("请选择SSID!");
		return;
	}

	var ssidtmp = str.replace(/\\/g,'\\\\');
	var ssid = ssidtmp.replace(/"/g,'\\"');

	var strpwd = $("#edtPasswrd").val();
	var pwdtmp = strpwd.replace(/\\/g,'\\\\');
	var pwd = pwdtmp.replace(/"/g,'\\"');
	
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"wifi_conn", "data":{"ssid":"'+ ssid + '", "pwd":"'+ pwd +'"}}';
	ajaxActionWrap(data, WifiConnCallBack);
	$("#wifiCurStatus").css("color", "#d84e4e");
	$("#wifiCurStatus").html("连接中");
	$("#waitgif").css("display","inline");
}

function wifiSearchTime()
{
	getWifiApList();
	$("#wifi_scan_status").css("display","none");
	$("#wifi_form").css("display","block");
}

function refresh_wifisearch()
{
	if(count == 0)
	{
		$("#waitgif2").css("display","inline");
		$("#wifi_scan_status").css("display","none");
		$("#wifi_form").css("display","block");
	}
	if(count < 8)
	{
		getWifiApList();
		setTimeout(refresh_wifisearch, 1000);
	}
	else
	{
		$("#waitgif2").css("display","none");
	}
	count++;
}


/*wifi搜索*/
function btnScanWifiOnClick()
{
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"wifi_scan",}';
	ajaxActionWrap(data);
	$("#wifi_scan_status").css("display","block");
	$("#wifi_form").css("display","none");
	count = 0;
	$("#ApCount").html("扫描到的热点：0");
	$("#wifiApList").empty();
	setTimeout(refresh_wifisearch, 800);
}

function WifigetAplistCallBack(data, status)
{
	var DataStatus = data.indexOf('failed');
	if(DataStatus > -1) return;
	
	if(status != "success")
	{
		//alert("获取WIFI热点列表失败!");
		return -1;
	}
	var jobj = eval(data);
	var i = 0;
	var length = $("#wifiApList")[0].length;
	if(jobj)
	{
		if(jobj[0].code != 1)
		{
			return 0;
		}
//		$("#wifiApList").empty();
		$("#wifiApList").append("<option value='' hidden>请选择WIFI</option>");
		for(i = length; i < jobj[0].wifi_aplist.length; i++)
		{
			$("#wifiApList").append("<option value="+ i +">"+ jobj[0].wifi_aplist[i].ssid +"</option>");
		}
		var str = "扫描到的热点：" + $("#wifiApList")[0].length;
		$("#ApCount").html(str);		
	}
}

/*获取WIFI热点列表
*eg: [{'status': 'success', 'code': 1, 'wifi_aplist':[{'ssid':'BJXDGC'},{'ssid':'555555'},,]}
*/
function getWifiApList()
{
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"wifi_getAplist",}';
	ajaxActionWrap(data, WifigetAplistCallBack); 	
}

function printCB(data, status)
{
	if(status != "success")
	{
		//alert("获取WIFI热点列表失败!");
		return -1;
	}
	else{
		alert("send ok!" + data);
	}
}

function btnPrintTest()
{
	devId = getCookie('devId')
	var printData = $("#edt_print_test").val();
	var data = '{"devId":"'+ devId +'","action":"print_test","data":"'+ printData +'"}';
	ajaxActionWrap(data, printCB);
}

function getSerConfigCB(data, status)
{
	if(status != "success")
	{
		//alert("获取WIFI热点列表失败!");
		return -1;
	}
	else{
		//alert("send ok!" + data);
		var jobj = eval(data);
		if(jobj)
		{
			if(jobj[0].code != 1)
			{
				return 0;
			}
			$('#edt_server').val(jobj[0].data.server);
			$('#edt_port').val(jobj[0].data.port);
		}
	}
}

function setSerConfigCB(data, status)
{
	if(status != "success")
	{
		//alert("获取WIFI热点列表失败!");
		return -1;
	}
	else{
		alert("send ok!" + data);
	}
}

function btnGetSerConfig()
{
	var devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"getSerConfig"}';
	ajaxActionWrap(data, getSerConfigCB); 
}

function btnsetSerConfig()
{
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"setSerConfig","data":{"server":"'+ $('#edt_server').val() +'","port":'+ $('#edt_port').val() +'}}';
	ajaxActionWrap(data, setSerConfigCB); 
}

function getVersionCB(data, status)
{
	if(status != "success")
	{
		return -1;
	}
	else{
		//alert("send ok!" + data);
		var jobj = eval(data);
		if(jobj)
		{
			if(jobj[0].code != 1)
			{
				return 0;
			}
			$('#softinfo').html("Version:" + jobj[0].data.version + "        Build:" + jobj[0].data.build);
		}
	}
}

function getVersion()
{
	devId = getCookie('devId');
	var data = '{"devId":"'+ devId +'","action":"getVersion"}';
	ajaxActionWrap(data, getVersionCB); 	
}

function setCookie(c_name,value,expiredays)
{
	var exdate=new Date()
	exdate.setDate(exdate.getDate()+expiredays)
	cookie_str = c_name+ "=" +escape(value)+
		((expiredays==null) ? "" : ";expires="+exdate.toGMTString())
	document.cookie = cookie_str;
	if(document.cookie == "" || document.cookie == null)
	{
		jsCookie = cookie_str;
	}
}

function getCookie(c_name)
{

	if(document.cookie.length>0)
	{
		cookie_str = document.cookie;
	}else{
		cookie_str = jsCookie;
	}
	
	if (cookie_str.length>0)
	{
	  c_start=cookie_str.indexOf(c_name + "=")
	  if (c_start!=-1)
		{ 
		c_start=c_start + c_name.length+1 
		c_end=cookie_str.indexOf(";",c_start)
		if (c_end==-1) c_end=cookie_str.length
		return unescape(cookie_str.substring(c_start,c_end))
		} 
	}
	
	return ""
}

function checkCookie()
{
	devId = getCookie('devId');
	if( devId != null && devId != "" )
	{
		$("#divlogin").css("display","none");
		$("#divcontent").css("display","block");
		return 1;
	}
	else 
	{
		$("#divlogin").css("display","block");
		$("#divcontent").css("display","none");
		return 0;
	}
}

function LoginDevIdCB(data, status)
{
	if(status != "success")
	{
		alert("请求服务失败");
		return -1;
	}
	else{
		var jobj = eval(data);
		if(!jobj)
		{
			alert("服务返回数据有误!");
			return -1;
		}
		if(jobj[0].code == 1)
		{
			if(loginType == 2)
				setCookie("devId", $('#devId').val());
			$("#divlogin").css("display","none");
			$("#divcontent").css("display","block");
			
			dataLoad();
			return 0;
		}else
		{
			$("#divlogin").css("display","block");
			$("#divcontent").css("display","none");	
			
			if(loginType == 2)
				alert("验证失败!");
			
			return -1;
		}
	}
}

function logout()
{
	document.cookie="";//setCookie("devId", "");
	$("#divlogin").css("display","block");
	$("#divcontent").css("display","none");
}


function btnLogin()
{
	devid = $('#devId').val();
	loginType = 2;
	
	if(devid == null || devid == "")
	{
		loginType = 1;
		devid = getCookie('devId');
	}	
	
	if(devid == null || devid == "")
	{
		logout();
		return;
	}	
	
	var data = '{"devId":"'+ devid +'","action":"login","data":{"devid":"'+ devid + '"}}';
	ajaxActionWrap(data, LoginDevIdCB); 
}

function setPrinterNameCB(data, status)
{
	if(status != "success")
	{
		alert("调用失败!");
		return -1;
	}
	else{
		var jobj = eval(data);
		if(!jobj)
		{
			alert("服务返回数据有误!");
			return -1;
		}
		if(jobj[0].code == 1)
		{
			getWifiStatus();
			showSetWifiPage();
			return 0;
		}else
		{
			alert("设置失败");
			return -1;
		}
	}
}

function btnChangeDevName()
{
	printerName = $.trim($('#edtPrinterName').val());
	if(printerName == null || printerName == "")
	{
		alert("设备名称不能为空");
		return;
	}
	/*
	if($.trim($("#labPrinterName").html()) == $.trim($('#edtPrinterName').val()))
	{
		showSetWifiPage();
		return;
	}
	*/
	ret = confirm("注:设置设备名称，需要重启设备,才会有效!");
	if(!ret)
		return;
	
	var data = '{"devId":"'+ devid +'","action":"setPrinterName","data":{"printerName":"'+ printerName + '"}}';
	ajaxActionWrap(data, setPrinterNameCB); 
}

function btnShowSetPrinterName()
{
	$("#sys_status").css("display","none");
	$("#wifi_form").css("display","none");
	$("#div_printerName_set").css("display","none");
}

function showSetWifiPage()
{
	$("#sys_status").css("display","block");
	$("#wifi_form").css("display","block");
	curap = $.trim($("#wifiCurAp").html());
	if( curap == "" || curap == null)
	{
		btnShowWifiBtnSetEx(0);
	}else{
		btnShowWifiBtnSetEx(1);	
	}
	$("#div_printerName_set").css("display","none");
}

function showSetPrinterNamePage()
{
	$("#sys_status").css("display","none");
	$("#wifi_form").css("display","none");
	$("#div_printerName_set").css("display","block");
	$("#edtPrinterName").val($("#labPrinterName").html());
}

function showMainPage()
{
	showSetWifiPage();
	return;
	$("#sys_status").css("display","block");
	$("#wifi_form").css("display","none");
	$("#div_printerName_set").css("display","none");
	$("#div_wifi_conn").css("display","none");
}

function btnBackToSetPrinterNamePage()
{
	showSetPrinterNamePage();
}

function btnShowWifiBtnSetEx(flag)
{
	if(flag)
	{
		$("#sbDesign1").css("display","block");
		$("#sbDesign").css("display","none");
	}else{
		$("#sbDesign1").css("display","none");
		$("#sbDesign").css("display","block");
	}
}

function btnShowWifiBtnSet()
{
	btnShowWifiBtnSetEx(0);
}

function dataLoad()
{
	getWifiStatus();
	btnGetSerConfig();
	getVersion();
	getWifiApList();
	
	//WifigetAplistCallBack1()
}

function btnExit()
{
	setCookie("devId", "");
	location.reload();
}

function load()
{
	btnLogin();
}
